Subject: Re: bug#14746: 24.3.50; update-file-autoloads: Generate absolute paths?

From: Stefan Monnier <[email-masked]>
Date: Fri, 28 Jun 2013 23:43:35 -0400

> 1. Eithe M-x update-file-autoloads should generate absolute filepaths.
> 2. (autoload ...) should be accomodative of relative paths in it's arguments.

The way autoload works is that it looks through load-path, and
autoload.el expects that the file containing those autoloads will be
placed in a directory that appears in load-path.

IOW, you're using it in a way that is very different from the one intended.

We could probably add a config var to make it work the way you expect,
tho we usually prefer relative file names, which makes the file
position-independent to some extent.

E.g. you could have a ~/elisp directory, then you could place all your
Elisp packages somewhere underneath ~/elisp and you can then do

1. C-x C-f ~/elisp/private/orgmuse.el
2. M-x update-file-autoloads
   When prompted for the where to write, say ~/elisp/autoloads

and in Emacs just add (load "~/elisp/autoloads").  And also add

  (add-to-list 'load-path (or (file-name-directory #$) (car load-path)))

at the beginning of ~/elisp/autoloads.

        Stefan